两数之和

题目描述:给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。

示例 :
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

1
2
3
4
5
class Solution {
public int[] twoSum(int[] nums, int target) {

}
}

方法一:一遍哈希表

通过以空间换取速度的方式,我们可以将查找时间从 O(n) 降低到 O(1)。哈希表正是为此目的而构建的,它支持以 近似 恒定的时间进行快速查找。我用“近似”来描述,是因为一旦出现冲突,查找用时可能会退化到 O(n)。但只要你仔细地挑选哈希函数,在哈希表中进行查找的用时应当被摊销为 O(1)。

在进行迭代并将元素插入表的同时,检查表中是否已经存在当前元素所对应的目标元素,如果有,则返回

1
2
3
4
5
6
7
8
9
10
11
12
13
class Solution {
public int[] twoSum(int[] nums, int target) {
Map<Integer, Integer>map = new HashMap<>(nums.length);
for(int i = 0; i < nums.length; i++) {
int temp = target - nums[i];
if(map.containsKey(temp)) {
return new int[] {map.get(temp), i};
}
map.put(nums[i], i);
}
throw new IllegalArgumentException("没有找到");
}
}

复杂度分析:

  • 时间复杂度:O(n),我们只遍历了包含有 n 个元素的列表一次。在表中进行的每次查找只花费 O(1) 的时间
  • 空间复杂度:O(n),所需的额外空间取决于哈希表中存储的元素数量,该表最多需要存储 n 个元素

执行结果:通过

  • 执行用时:2 ms, 在所有 Java 提交中击败了99.62%的用户
  • 内存消耗:40 MB, 在所有 Java 提交中击败了52.39%的用户

方法二:两遍哈希表

在第一次迭代中,我们将每个元素的值和它的索引添加到表中。然后,在第二次迭代中,我们将检查每个元素所对应的目标元素(target - nums[i])是否存在于表中。注意,该目标元素不能是 nums[i] 本身!

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
class Solution {
public int[] twoSum(int[] nums, int target) {
Map<Integer, Integer>map = new HashMap<Integer, Integer>();
for(int i = 0; i < nums.length; i++) {
map.put(nums[i], i);
}
for(int i = 0; i < nums.length; i++) {
int temp = target - nums[i];
if(map.containsKey(temp) && map.get(temp) != i) {
return new int[] {i, map.get(temp)};
}
}
throw new IllegalArgumentException("没有找到");
}
}

复杂度分析:

  • 时间复杂度:O(n),我们把包含有 n 个元素的列表遍历两次。由于哈希表将查找时间缩短到 O(1),所以时间复杂度为 O(n)
  • 空间复杂度:O(n),所需的额外空间取决于哈希表中存储的元素数量,该表中存储了 n 个元素

执行结果:通过

  • 执行用时:3 ms, 在所有 Java 提交中击败了73.61%的用户
  • 内存消耗:40.1 MB, 在所有 Java 提交中击败了27.80%的用户

方法三:暴力法

暴力法很简单,遍历每个元素 xx,并查找是否存在一个值与 target - x 相等的目标元素。

1
2
3
4
5
6
7
8
9
10
11
12
class Solution {
public int[] twoSum(int[] nums, int target) {
for (int i = 0; i < nums.length; i++) {
for (int j = i + 1; j < nums.length; j++) {
if (nums[j] == target - nums[i]) {
return new int[] { i, j };
}
}
}
throw new IllegalArgumentException("No two sum solution");
}
}

复杂度分析:

  • 时间复杂度:O(n^2),对于每个元素,我们试图通过遍历数组的其余部分来寻找它所对应的目标元素,这将耗费 O(n) 的时间。因此时间复杂度为 O(n^2)
  • 空间复杂度:O(1)

执行结果:通过

  • 执行用时:92 ms, 在所有 Java 提交中击败了12.29%的用户
  • 内存消耗:40.1 MB, 在所有 Java 提交中击败了33.36%的用户